<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xmlns:ui="http://java.sun.com/jsf/facelets" xmlns:h="http://java.sun.com/jsf/html" xmlns:f="http://java.sun.com/jsf/core"
	xmlns:ship="http://xmlns.jcp.org/jsf/composite/ship" xmlns:p="http://primefaces.org/ui">
<h:head></h:head>
<h:body>
	<ui:composition template="/pages/primodaltemplate.xhtml">
		<ui:define name="title">
			<h:outputText value="#{facesContext.translate('title.study.deptmeta.add', studyModel.element.name)}" />
		</ui:define>
		<ui:define name="body">
			<p:dataTable id="datatable" value="#{studyModel.deptmeta}" var="m">
				<p:column id="unique_name" headerText="#{facesContext.translate('label.study.variable.meta.referencevariable')}">
					<h:outputText value="#{m.uniqueName}" styleClass="#{m.persisted ? '' : 'dirty'}" />
				</p:column>
				<p:column id="type_name" headerText="#{facesContext.translate('label.study.variable.meta.type')}">
					<h:outputText value="#{m.typeName}" styleClass="#{m.persisted ? '' : 'dirty'}" />
				</p:column>
				<p:column id="affected" headerText="#{facesContext.translate('study.meta.affected')}" style="width: 100px; text-align: center">
					<h:outputText value="#{m.affected}" styleClass="#{m.persisted ? 'squarebadge' : 'squarebadgedirty'}" style="margin-right: 8px;" />
					<p:commandButton id="show_affected" value="" title="#{facesContext.translate('button.show')}" type="button" styleClass="iconbutton" style="font-size: large" icon="pi pi-eye" onclick="alert('#{m.affectedUniqueNames}')" />
				</p:column>
				<p:column id="actions" headerText="#{facesContext.translate('label.actions')}" styleClass="oneiconbutton">
					<ship:removeButton action="#{studyController.doRemoveMetadata(m.pk, m.typeName, studyModel.element)}" tooltip="#{facesContext.translate('button.delete')}" immediate="true"
						approveButtonLabel="#{facesContext.translate('button.yes')}" cancelButtonLabel="#{facesContext.translate('button.no')}" title="#{facesContext.translate('title.delete.approve')}">
						<h:outputText value="#{facesContext.translate('confirmation.delete.deptmeta', studyModel.element.name, m.affected)}" />
					</ship:removeButton>
				</p:column>
			</p:dataTable>
			<p:dialog widgetVar="add_list_item" header="#{facesContext.translate('title.study.deptmeta.edit', studyModel.element.name)}" closable="false" closeOnEscape="false">
				<p:panelGrid id="breadcrumb" columns="2">
					<h:outputText value="#{facesContext.translate('label.study.variable.meta.variablelistparent')}" />
					<div style="padding-bottom: 20px">
						<ui:repeat value="#{studyModel.parents}" var="b" varStatus="status">
							<p:commandButton id="btn_deptmeta" action="#{studyController.toDeptmeta(studyModel.element, b.id)}" value="#{b.name}"
								look="#{b.id == studyModel.variablelistParentId ? 'primary' : 'default'}" ajax="true" update="form:addlistitem form:breadcrumb form:btngrp" />
						</ui:repeat>
					</div>
				</p:panelGrid>
				<p:panelGrid id="addlistitem" columns="2" columnClasses=",maxheight400">
					<h:outputText value="#{facesContext.translate('label.study.variable.meta.type')}" />
					<p:selectOneMenu id="metadatatype" value="#{studyModel.newMetadataBean.metadataTypeJson}">
						<f:selectItem itemValue="" itemLabel="#{facesContext.translate('button.choose')}" />
						<f:selectItems value="#{studyModel.metadatatypes}" var="t" itemLabel="#{t.name} - #{t.description}" itemValue="#{t.toJson()}" />
					</p:selectOneMenu>
					<h:outputText value="#{facesContext.translate('label.study.variable.meta.referencevariable')}" />
					<p:selectOneMenu id="referenceelement" value="#{studyModel.newMetadataBean.fkReferenceElement}">
						<f:selectItem itemValue="" itemLabel="#{facesContext.translate('button.choose')}" />
						<f:selectItems value="#{studyModel.allReferenceVariables}" var="v" itemLabel="#{v.uniqueName}" itemValue="#{v.id}" />
					</p:selectOneMenu>
					<h:outputText value="#{facesContext.translate('study.meta.affected')}" />
          <ui:fragment>
            <div style="overflow: auto; max-height: 50vh">
					    <ui:repeat value="#{studyModel.children}" var="c" varStatus="status">
              <!-- TODO: use li instead to make it more user friendly -->
						    <p:selectBooleanCheckbox id="selected_#{status.index}" value="#{c.isSelected}" itemLabel="#{c.uniqueName}: #{c.title}" title="#{c.title}" /><br />
					    </ui:repeat>
            </div>
          </ui:fragment>
				</p:panelGrid>
				<ship:buttongroup id="btngrp">
					<p:button icon="fa fa-question-circle" tooltip="#{facesContext.translate('button.help')}" onclick="PF('internalHelpModal').show();return;"
						style="background-color: gray !important; border-color: silver !important" />
					<p:commandButton id="btn_approve" action="#{studyController.doAddDeptmeta(studyModel.element)}" ajax="false"
						value="#{facesContext.translate('button.approve.changes.deptmeta', studyModel.element.name)}" look="primary" />
					<p:button id="btn_cancel" value="#{facesContext.translate('button.cancel')}" onclick="PF('add_list_item').hide();return;" />
				</ship:buttongroup>
			</p:dialog>
			<p:dialog widgetVar="internalHelpModal" header="#{facesContext.translate('button.help')}" closable="true" closeOnEscape="true" width="50%">
				<ui:fragment id="internal_help_en" rendered="#{lang.localeCode == 'en'}">
	  	    You can define a new process variable here. In the first line you can see the hierarchical level you’re on. By clicking on the name of the preferred section you can navigate through the hierarchy. Below, you should specify the type of the process variable (e.g. observer-, device-, starttime-variable...). Then you must select the process variable and determine which variables in this area should be affected by the settings. By default, all variables are selected.
  		  </ui:fragment>
				<ui:fragment id="internal_help_de_DE" rendered="#{lang.localeCode == 'de_DE'}">
		    	Hier können Sie eine neue Prozessvariable definieren. Auf welcher Hierarchieebene Sie sich befinden, sehen Sie in der ersten Zeile. Durch einen Klick auf den entsprechenden Namen können Sie durch die Bereiche navigieren. Darunter sollte der Typ der Prozessvariable angegeben werden (z.B. observer-, device-, starttime-variable....). Dann müssen Sie die Prozessvariable auswählen und als letztes bestimmen, für welche der Variablen des Bereichs die Einstellungen gelten sollen. Als Voreinstellung sind alle Variablen ausgewählt.
		    </ui:fragment>
				<p:button value="#{facesContext.translate('button.ok')}" onclick="PF('internalHelpModal').hide();return;" />
			</p:dialog>
		</ui:define>
		<ui:define name="formbuttons">
			<p:button value="#{facesContext.translate('button.add')}" onclick="PF('add_list_item').show();return;" />
			<p:commandButton id="btn_ok" action="#{studyController.doApproveDeptmeta(studyModel.element)}" value="#{facesContext.translate('button.approve')}" ajax="false" styleClass="#{studyModel.hasDirtyDeptmeta() ? 'dirty' : ''}" />
			<p:commandButton id="btn_abort" action="#{studyController.doRevertDeptmeta(studyModel.element)}" value="#{facesContext.translate('button.cancel')}" ajax="false" immediate="true" />
		</ui:define>
		<ui:define name="help_de">
			Hier sind alle Zuordnungen von Prozessvariablen zu Variablen im gewählten Bereich aufgelistet. Um anzuzeigen, welchen Variablen eine Prozessvariable jeweils zugeordnet ist, klicken Sie auf den Button in der betreffenden Spalte der Tabelle. Bestehende Zuordnungen können durch Klicken des Papierkorb-Symbols gelöscht werden. Um eine Prozessvariable zu neu zuzuordnen, klicken Sie auf <i>Hinzufügen</i>.
		</ui:define>
		<ui:define name="help_en">
			All assignemnts of process variables to variables in the selected study section are listed here. To see which variables are assigned to a certain process variable, click on the button in the respective column of the table. Existing assignemnts can be deleted by clicking the recycle bin-symbol. To newly assign a process variable, please click <i>add</i>.
		</ui:define>
	</ui:composition>
</h:body>
</html>
